
%% Lockdown grid
% in covidmacro.mod file set capacity = 1, lockdown = 1, mp = 0
clear all

dynare covidmacro nostrict
xx = oo_.endo_simul;
save('init_covid.mat', 'xx', '-append')
% xx_start = oo_.endo_simul;
% save('init_covid.mat', 'xx_start', '-append')

run=0; %0 sticky price without NRI; 1 flex price; 2 sticky price with NRI
% change also mod file

%use the 2 lines below if grid starts from (0,0)
xx_start=xx0;
save('init_covid.mat', 'xx_start', '-append')

grid_tauc=[0:2:20];  nx = size(grid_tauc,2);
grid_taun=[0:2:20];  ny = size(grid_taun,2);
nx*ny

Results.Lossc = nan(nx,ny);
Results.LossC = nan(nx,ny);
Results.D     = nan(nx,ny);
Results.U_s   = nan(nx,ny);
Results.Util  = nan(nx,ny);
Results.LossU = nan(nx,ny);
Fail=[];

if run == 1
    NRI=[];
end
if run == 2
    load NRI
end
    
for ii=1:nx
    for jj=1:ny

        if run == 1    
            M_.params(find(ismember(M_.param_names,'delt','rows'))) = 0;    
        end
        
        
        M_.params(find(ismember(M_.param_names,'Phi_lock_c','rows'))) = grid_tauc(ii);
        M_.params(find(ismember(M_.param_names,'Phi_lock_n','rows'))) = grid_taun(jj);  

        perfect_foresight_setup;
        
        if run == 2    
            oo_.exo_simul(2:end-1,find(ismember(M_.exo_names,'NRI','rows'))) = squeeze(NRI(ii,jj,:));      
        end
        
        load init_covid
        if jj==1
            oo_.endo_simul = xx_start;
        else
            oo_.endo_simul = xx;
        end
        
        perfect_foresight_solver;
        
        if ~oo_.deterministic_simulation.status
            Fail = [Fail; [ii jj]];
        else
        
            Welfare = 0;
            for i=2:size(oo_.endo_simul,2)-2
                Welfare = Welfare + bet^i.*Util(i);
            end
            Welfare = Welfare + bet^size(oo_.endo_simul,2).*Util(size(oo_.endo_simul,2)-1)./(1-bet);

            % Aggregate welfare 
            %Results.Util(ii,jj) = Welfare;   
            Results.Util(ii,jj) = U_s(2);   
            % Aggregate welfare loss in p.c. of steady state consumption
            Results.LossU(ii,jj) = -(exp((1-bet)*Welfare + thet*n_s(1))/c_s(1)-1);   
            % Dead
            Results.D(ii,jj) = 100*D(250);    
            % Average percent deviation of per capita consumption from ss over 2 years
            Results.Lossc(ii,jj) = 100-100*sum(c(1:104)./Pop(1:104))/104/c(1); 
            % Average percent deviation of aggregate consumption from ss over 2 years
            Results.LossC(ii,jj) = 100-100*sum(c(1:104))/104/c(1); 
            % Utility of S when pandemic starts
            Results.U_s(ii,jj) = U_s(2);  
            % NRI (set flexible prices in mod file)
            if run==1
                NRI(ii,jj,:)=RR(2:251)./pic(3:252)-RR(1)/pic(1);
            end
            
            xx = oo_.endo_simul;
            save('init_covid.mat', 'xx', '-append')

            if jj==1
                xx_start = oo_.endo_simul;
                save('init_covid.mat', 'xx_start', '-append')
            end
        
        end
        
    end
end

save tradeoff_lock Results
if run==1
    save('NRI.mat', 'NRI', '-append')
end

Fail

%% Monetary policy grid

clear all

dynare covidmacro nostrict
xx = oo_.endo_simul;
save('init_covid.mat', 'xx', '-append')
xx_start = oo_.endo_simul;
save('init_covid.mat', 'xx_start', '-append')


grid_Phi_I=[-0.1:0.01:0.1];  nx = size(grid_Phi_I,2); %

grid_Phi_I_d=[0]; ny = size(grid_Phi_I_d,2);%

nx*ny

Results.Lossc = nan(nx,ny);
Results.LossC = nan(nx,ny);
Results.D     = nan(nx,ny);
Results.U_s   = nan(nx,ny);
Results.Util  = nan(nx,ny);
Results.LossU = nan(nx,ny);
Fail=[];
   
for ii=1:nx
    for jj=1:ny
        
        M_.params(find(ismember(M_.param_names,'Phi_I','rows'))) = grid_Phi_I(ii);
        M_.params(find(ismember(M_.param_names,'Phi_I_d','rows'))) = grid_Phi_I_d(jj);  
        
        perfect_foresight_setup;
               
        load init_covid
        if jj==1
            oo_.endo_simul = xx_start;
        else
            oo_.endo_simul = xx;
        end
       
      
        perfect_foresight_solver;
        
        if ~oo_.deterministic_simulation.status
            Fail = [Fail; [ii jj]];
        else
        
            Welfare = 0;
            for i=2:size(oo_.endo_simul,2)-2
                Welfare = Welfare + bet^i.*Util(i);
            end
            Welfare = Welfare + bet^size(oo_.endo_simul,2).*Util(size(oo_.endo_simul,2)-1)./(1-bet);

            % Aggregate welfare 
            %Results.Util(ii,jj) = Welfare;  
            Results.Util(ii,jj) = U_s(2); 
            % Aggregate welfare loss in p.c. of steady state consumption
            Results.LossU(ii,jj) = -(exp((1-bet)*Welfare + thet*n_s(1))/c_s(1)-1);   
            % Dead
            Results.D(ii,jj) = 100*D(250);    
            % Average percent deviation of per capita consumption from ss over 2 years
            Results.Lossc(ii,jj) = 100-100*sum(c(1:104)./Pop(1:104))/104/c(1); 
            % Average percent deviation of aggregate consumption from ss over 2 years
            Results.LossC(ii,jj) = 100-100*sum(c(1:104))/104/c(1); 
            % Utility of S when pandemic starts
            Results.U_s(ii,jj) = U_s(2); 

            
            xx = oo_.endo_simul;
            save('init_covid.mat', 'xx', '-append')

            if jj==1
                xx_start = oo_.endo_simul;
                save('init_covid.mat', 'xx_start', '-append')
            end
        
        end
        
    end
end


%save tradeoff_mp_lock Results        % capacity = 1, lockdown = 1, mp = 0
%save tradeoff_mp_nolock Results     % capacity = 1, lockdown = 0, mp = 0

Fail

%% Optimal monetary policy plots
%find optimal policy
maximum=max(Results.Util(:));
[row,col] =find(Results.Util==maximum);
X=repmat(grid_Phi_I,size(grid_Phi_I_d'));
Y=repmat(grid_Phi_I_d',size(grid_Phi_I));
disp(['max:',num2str(maximum),'          dead:',num2str(100*D(249)), '    level:',num2str(X(1,row)),'    growth:',num2str(Y(col,1))]);

%plot surface of utility
figure;
plot(X,Results.Util');

% surf(X,Y,Results.Util')
% hold on
% scatter3(X(1,row),Y(col,1),Results.Util(row,col),'filled','r')
% xlabel('level')
% ylabel('growth')
% legend('Welfare','Optimum')

%plot impact of optimal policy on interest rate (annual)
figure;
plot(((exp(I(2:end)).^X(1,row)).*(exp(I(2:end)-I(1:end-1)).^Y(col,1))).^52-1);
hold on
plot(I(2:end),'r')
legend('optimal impact on interest rate', 'Infected')


%% Plot 5 scenarios - Figure 1
clear all
cd Z:\Documents\Epi-MMB\BKM_22\Codes;
cd Z:\Documents\Epi-MMB\BKM_22\Codes\Results;
load results_no_contaiment_baselineMP
hor = 100;
figure;
subplot(3,3,1),plot(100*S(1:hor)/Pop(1), 'LineWidth',2.5); title('Susceptibles'); hold on
subplot(3,3,2),plot(100*(I(1:hor)+IA(1:hor))/Pop(1), 'LineWidth',2.5); title('Infected (with asymptomatic)');hold on
subplot(3,3,3),plot(100*(R(1:hor)+RA(1:hor))/Pop(1), 'LineWidth',2.5); title('Recovered (with asymptomatic)');hold on
subplot(3,3,4),plot(100*D(1:hor)/Pop(1), 'LineWidth',2.5); title('Deceased');hold on
subplot(3,3,5),plot(100*[c(1); c(2:hor)]/c(1)-100 , 'LineWidth',2.5); title('GDP');hold on
subplot(3,3,6),plot(100*OG(1:hor) , 'LineWidth',2.5); title('Output gap');hold on
subplot(3,3,7),plot(100*inf(1:hor).^1 -100 , 'LineWidth',2.5); title('Inflation (Y-o-Y)');hold on
subplot(3,3,8),plot(100*nR(1:hor), 'LineWidth',2.5); title('Interest rate (1Y)');hold on
subplot(3,3,9),plot(100*rR(1:hor), 'LineWidth',2.5); title('Ex ante real interest rate (1Y)');hold on


load results_lockdown_baselineMP
hor = 100;
subplot(3,3,1),plot(100*S(1:hor)/Pop(1),'LineWidth',1.5); title('Susceptibles'); hold on
subplot(3,3,2),plot(100*(I(1:hor)+IA(1:hor))/Pop(1),'LineWidth',1.5); title('Infected (with asymptomatic)');hold on
subplot(3,3,3),plot(100*(R(1:hor)+RA(1:hor))/Pop(1),'LineWidth',1.5); title('Recovered (with asymptomatic)');hold on
subplot(3,3,4),plot(100*D(1:hor)/Pop(1),'LineWidth',1.5); title('Deceased');hold on
subplot(3,3,5),plot(100*[c(1); c(2:hor)]/c(1)-100 ,'LineWidth',1.5); title('GDP');hold on
subplot(3,3,6),plot(100*OG(1:hor) ,'LineWidth',1.5); title('Output gap');hold on
subplot(3,3,7),plot(100*inf(1:hor).^1 -100 ,'LineWidth',1.5); title('Inflation (Y-o-Y)');hold on
subplot(3,3,8),plot(100*nR(1:hor),'LineWidth',1.5); title('Interest rate (1Y)');hold on
subplot(3,3,9),plot(100*rR(1:hor),'LineWidth',1.5); title('Ex ante real interest rate (1Y)');hold on


load results_isolation_baselineMP
hor = 100;
subplot(3,3,1),plot(100*S(1:hor)/Pop(1),'--', 'LineWidth',1.5); title('Susceptibles'); hold on
subplot(3,3,2),plot(100*(I(1:hor)+IA(1:hor))/Pop(1),'--', 'LineWidth',1.5); title('Infected (with asymptomatic)');hold on
subplot(3,3,3),plot(100*(R(1:hor)+RA(1:hor))/Pop(1),'--', 'LineWidth',1.5); title('Recovered (with asymptomatic)');hold on
subplot(3,3,4),plot(100*D(1:hor)/Pop(1),'--', 'LineWidth',1.5); title('Deceased');hold on
subplot(3,3,5),plot(100*[c(1); c(2:hor)]/c(1)-100,'--', 'LineWidth',1.5); title('GDP');hold on
subplot(3,3,6),plot(100*OG(1:hor),'--', 'LineWidth',1.5); title('Output gap');hold on
subplot(3,3,7),plot(100*inf(1:hor).^1 -100,'--', 'LineWidth',1.5); title('Inflation (Y-o-Y)');hold on
subplot(3,3,8),plot(100*nR(1:hor),'--', 'LineWidth',1.5); title('Interest rate (1Y)');hold on
subplot(3,3,9),plot(100*rR(1:hor),'--', 'LineWidth',1.5); title('Ex ante real interest rate (1Y)');hold on


load results_isolation_and_lockdown_baselineMP
hor = 100;
subplot(3,3,1),plot(100*S(1:hor)/Pop(1),'-.', 'LineWidth',1.5); title('Susceptibles');
subplot(3,3,2),plot(100*(I(1:hor)+IA(1:hor))/Pop(1),'-.', 'LineWidth',1.5); title('Infected (with asymptomatic)');
subplot(3,3,3),plot(100*(R(1:hor)+RA(1:hor))/Pop(1),'-.', 'LineWidth',1.5); title('Recovered (with asymptomatic)');
subplot(3,3,4),plot(100*D(1:hor)/Pop(1),'-.','LineWidth',1.5); title('Deceased');
subplot(3,3,5),plot(100*[c(1); c(2:hor)]/c(1)-100,'-.', 'LineWidth',1.5); title('GDP');
subplot(3,3,6),plot(100*OG(1:hor),'-.', 'LineWidth',1.5); title('Output gap');
subplot(3,3,7),plot(100*inf(1:hor).^1 -100,'-.', 'LineWidth',1.5); title('Inflation (Y-o-Y)');
subplot(3,3,8),plot(100*nR(1:hor),'-.', 'LineWidth',1.5); title('Interest rate (1Y)');
subplot(3,3,9),plot(100*rR(1:hor),'-.', 'LineWidth',1.5); title('Ex ante real interest rate (1Y)');


load results_strict_lockdown_baselineMP
hor = 100;
subplot(3,3,1),plot(100*S(1:hor)/Pop(1),':', 'LineWidth',1.5); title('Susceptibles');
subplot(3,3,2),plot(100*(I(1:hor)+IA(1:hor))/Pop(1),':', 'LineWidth',1.5); title('Infected (with asymptomatic)');
subplot(3,3,3),plot(100*(R(1:hor)+RA(1:hor))/Pop(1),':', 'LineWidth',1.5); title('Recovered (with asymptomatic)');
subplot(3,3,4),plot(100*D(1:hor)/Pop(1),':', 'LineWidth',1.5); title('Deceased');
subplot(3,3,5),plot(100*[c(1); c(2:hor)]/c(1)-100,':', 'LineWidth',1.5); title('GDP');
subplot(3,3,6),plot(100*OG(1:hor),':', 'LineWidth',1.5); title('Output gap');
subplot(3,3,7),plot(100*inf(1:hor).^1 -100,':', 'LineWidth',1.5); title('Inflation (Y-o-Y)');
subplot(3,3,8),plot(100*nR(1:hor),':', 'LineWidth',1.5); title('Interest rate (1Y)');
subplot(3,3,9),plot(100*rR(1:hor),':', 'LineWidth',1.5); title('Ex ante real interest rate (1Y)');

legend('no containment measueres',  'baseline lockdown','isolation of infected','isolation & lockdown','strict lockdown');

%% Plot baseline vs optimal and standard monetary policy - Figures 2-6
clear all

load results_no_contaiment_baselineMP
% load results_lockdown_baselineMP
% load results_isolation_baselineMP
% load results_isolation_and_lockdown_baselineMP
% load results_strict_lockdown_baselineMP

hor = 100;
figure;
subplot(3,3,1),plot(100*S(1:hor)/Pop(1),'LineWidth',1.5); title('Susceptibles'); hold on
subplot(3,3,2),plot(100*(I(1:hor)+IA(1:hor))/Pop(1),'LineWidth',1.5); title('Infected (with asymptomatic)');hold on
subplot(3,3,3),plot(100*(R(1:hor)+RA(1:hor))/Pop(1),'LineWidth',1.5); title('Recovered (with asymptomatic)');hold on
subplot(3,3,4),plot(100*D(1:hor)/Pop(1),'LineWidth',1.5); title('Deceased');hold on
subplot(3,3,5),plot(100*[c(1); c(2:hor)]/c(1)-100 ,'LineWidth',1.5); title('GDP');hold on
subplot(3,3,6),plot(100*OG(1:hor),'LineWidth',1.5); title('Output gap');hold on
subplot(3,3,7),plot(100*inf(1:hor).^1 -100 ,'LineWidth',1.5); title('Inflation (Y-o-Y)');hold on
subplot(3,3,8),plot(100*nR(1:hor),'LineWidth',1.5); title('Interest rate (1Y)');hold on
subplot(3,3,9),plot(100*rR(1:hor),'LineWidth',1.5); title('Ex ante real interest rate (1Y)');hold on

load results_no_contaiment_standardMP
% load results_lockdown_standardMP
% load results_isolation_standardMP
% load results_isolation_and_lockdown_standardMP
% load results_strict_lockdown_standardMP

hor = 100;
subplot(3,3,1),plot(100*S(1:hor)/Pop(1),'--', 'LineWidth',1.5); title('Susceptibles'); hold on
subplot(3,3,2),plot(100*(I(1:hor)+IA(1:hor))/Pop(1),'--', 'LineWidth',1.5); title('Infected (with asymptomatic)');hold on
subplot(3,3,3),plot(100*(R(1:hor)+RA(1:hor))/Pop(1),'--', 'LineWidth',1.5); title('Recovered (with asymptomatic)');hold on
subplot(3,3,4),plot(100*D(1:hor)/Pop(1),'--','LineWidth',1.5); title('Deceased');hold on
subplot(3,3,5),plot(100*[c(1); c(2:hor)]/c(1)-100,'--', 'LineWidth',1.5); title('GDP');hold on
subplot(3,3,6),plot(100*OG(1:hor),'--', 'LineWidth',1.5); title('Output gap');hold on
subplot(3,3,7),plot(100*inf(1:hor).^1 -100,'--', 'LineWidth',1.5); title('Inflation (Y-o-Y)');hold on
subplot(3,3,8),plot(100*nR(1:hor),'--', 'LineWidth',1.5); title('Interest rate (1Y)');hold on
subplot(3,3,9),plot(100*rR(1:hor),'--', 'LineWidth',1.5); title('Ex ante real interest rate (1Y)');hold on

load results_no_contaiment_optimalMP
% load results_lockdown_optimalMP
% load results_isolation_optimalMP
% load results_isolation_and_lockdown_optimalMP
% load results_strict_lockdown_optimalMP

hor = 100;
subplot(3,3,1),plot(100*S(1:hor)/Pop(1),':','Color','k', 'LineWidth',1.5); title('Susceptibles');
subplot(3,3,2),plot(100*(I(1:hor)+IA(1:hor))/Pop(1),':','Color','k', 'LineWidth',1.5); title('Infected (with asymptomatic)');
subplot(3,3,3),plot(100*(R(1:hor)+RA(1:hor))/Pop(1),':','Color','k', 'LineWidth',1.5); title('Recovered (with asymptomatic)');
subplot(3,3,4),plot(100*D(1:hor)/Pop(1),':','Color','k', 'LineWidth',1.5); title('Deceased');
subplot(3,3,5),plot(100*[c(1); c(2:hor)]/c(1)-100,':','Color','k', 'LineWidth',1.5); title('GDP');
subplot(3,3,6),plot(100*OG(1:hor),':', 'Color','k','LineWidth',1.5); title('Output gap');
subplot(3,3,7),plot(100*inf(1:hor).^1 -100,':','Color','k', 'LineWidth',1.5); title('Inflation (Y-o-Y)');
subplot(3,3,8),plot(100*nR(1:hor),':', 'Color','k','LineWidth',1.5); title('Interest rate (1Y)');
subplot(3,3,9),plot(100*rR(1:hor),':', 'Color','k','LineWidth',1.5); title('Ex ante real interest rate (1Y)');

legend('baseline monetary policy','standard monetary policy', 'optimized monetary policy');


%% Plot tradeoff - Figure 7
figure;
load tradeoff_lock
plot((Results.LossC(1:11)),(Results.D(1:11)), 'LineWidth',3)
hold on
load tradeoff_mp_nolock
plot((Results.LossC),(Results.D),'-.', 'LineWidth',3)
load tradeoff_mp_lock
plot((Results.LossC),(Results.D),'-.', 'LineWidth',3)


grid on
legend('lockdowns (with baseline monetary policy)', 'monetary policy (without containment measures)', 'monetary policy (with baseline lockdown)')
xlabel('\bf Consumption loss');
ylabel('\bf Life loss');


%% Welfare calculation
%load results_no_contaiment_baselineMP
%load results_lockdown_baselineMP
%load results_isolation_baselineMP
%load results_isolation_and_lockdown_baselineMP
%load results_strict_lockdown_baselineMP

%load results_no_contaiment_standardMP
%load results_lockdown_standardMP
%load results_isolation_standardMP
%load results_isolation_and_lockdown_standardMP
%load results_strict_lockdown_standardMP

%load results_no_contaiment_optimalMP
%load results_lockdown_optimalMP
%load results_isolation_optimalMP
%load results_isolation_and_lockdown_optimalMP
%load results_strict_lockdown_optimalMP

x = exp((1-bet)*U_s(2) - log(c_s(1)) - thet*log(1-n_s(1)))-1;
fprintf(' welfare  = %12.6f \n',x);
fprintf(' deceased (250)  = %12.6f, \n',D(250));

